pkgsh/test/runner

51 lines
1.3 KiB
Plaintext
Raw Normal View History

2014-06-16 23:24:18 -04:00
#!/bin/bash
# Test runner
#
# Copyright (C) 2014 Mike Gerwitz
#
# This file is part of pkgsh.
#
# pkgsh is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# You should invoke all tests using this runner rather than executing the
# tests directly.
##
# determine our wd, but don't change directories (so that run-test can do
# its own magic)
__mypath="$( dirname "$0" )" || {
echo "fatal: could not determine runner directory" >&2
exit 1
}
readonly __mypath
main()
{
local -i fail=0
# run each test in an isolated process with a fresh environment
for tcase in "$@"; do
env -i "$__mypath/run-test" "$tcase" || {
echo "failure [$?]: $tcase" >&2
fail=1
}
done
test "$fail" -eq 0
}
main "$@"